

baleforkExtra = {};

function baleforkExtra.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function baleforkExtra:load(xmlFile)
--balesFixed
	 self.Attacher = {};
	 self.Attacher.object = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.balesAttacherPoint#index"));
	 setRigidBodyType(self.Attacher.coll,"none")
	 self.Attacher.attachedObject = nil;
	 self.Attacher.objectInRange = nil;
--balesFixed_end
	self.balesInRangePoint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.balesAttacherPoint#index"));
	self.setBalesInRange = SpecializationUtil.callSpecializationsFunction("setBalesInRange");
	self.balesSafety = false;
end;


function baleforkExtra:getSaveAttributesAndNodes(nodeIdent)
        BaleforkObjectDetach(self,i)
    return nil;
end;

function baleforkExtra:delete()
end;

function baleforkExtra:mouseEvent(posX, posY, isDown, isUp, button)
end;

function baleforkExtra:keyEvent(unicode, sym, modifier, isDown)
end;

function baleforkExtra:update(dt)
--balesFixed
	if self:getIsActiveForInput() then
		if InputBinding.isPressed(InputBinding.TOGGLE_BALESDETACH) then
				BaleforkObjectDetach(self)
				self.balesSafety = false;
		end;

		if InputBinding.isPressed(InputBinding.TOGGLE_BALESATTACH) then
				nearest = BaleforkObjectInRange(self);
				self.Attacher.objectInRange = nearest;
				BaleforkObjectAttach(self)
				self.balesSafety = true;
		end;
	end;
--balesFixed_end
	self:setBalesInRange ();

end;

function baleforkExtra:draw()

	if self.attacherVehicle then
		if self.balesSafety then
			g_currentMission:addExtraPrintText(string.format(g_i18n:getText("touch").."%s"..g_i18n:getText("bales release"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_BALESDETACH)));
		elseif self.balesInRange then
			g_currentMission:addExtraPrintText(string.format(g_i18n:getText("touch").."%s"..g_i18n:getText("bales protect"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_BALESATTACH)));
		end;
	end;

end;

function baleforkExtra:onAttach(attacherVehicle)
end;

function baleforkExtra:setBalesInRange()
	self.balesInRange = false;
	local nearestObject
	local itemNode
	local nearestDistance = 1.2;
	local px, py, pz = getWorldTranslation(self.balesInRangePoint);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isRoundStrawbale") or getUserAttribute(itemNode, "isRoundHaybale") or getUserAttribute(itemNode, "isHaybale") or getUserAttribute(itemNode, "isStrawbale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					nearestObject = itemNode
					nearestDistance = distance
					self.balesInRange = true;
				end;
			end;
		end;
	end;
	return nearestObject
end;

function BaleforkObjectInRange(self)

	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 1.2;
	local px, py, pz = getWorldTranslation(self.Attacher.object);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isRoundStrawbale") or getUserAttribute(itemNode, "isRoundHaybale") or getUserAttribute(itemNode, "isHaybale") or getUserAttribute(itemNode, "isStrawbale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = i
					nearestObject = itemNode
					nearestDistance = distance
					self.balesInRange = true;
				end;
			end;
		end;
	end;
	return nearestObject, index
end;

function BaleforkObjectAttach(self)
	if self.Attacher.objectInRange ~= nil then
		if self.Attacher.attachedObject == nil then
			setRigidBodyType(self.Attacher.objectInRange,"none");
			local x,y,z = getWorldRotation(self.Attacher.objectInRange);		
			link(self.Attacher.object,self.Attacher.objectInRange);
			setRotation(self.Attacher.objectInRange, 0,0,0);
			setTranslation(self.Attacher.objectInRange, 0,0,0)
			self.Attacher.attachedObject = self.Attacher.objectInRange;
			self.Attacher.objectInRange = nil;
		end;
	end;
end;

function BaleforkObjectDetach(self)
	if self.Attacher.attachedObject ~= nil then			
		local x,y,z = getWorldTranslation(self.Attacher.attachedObject)
		local rx,ry,rz = getWorldRotation(self.Attacher.attachedObject)
		local root = getRootNode()
		setTranslation(self.Attacher.attachedObject,x,y,z)
		setRotation(self.Attacher.attachedObject,rx,ry,rz)
		link(root,self.Attacher.attachedObject)
		setRigidBodyType(self.Attacher.attachedObject,"Dynamic")
		self.Attacher.attachedObject = nil;
	end;
end;