

bergmann = {};

function bergmann.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function bergmann:load(xmlFile)

-- brakeLights
	self.numbrakelights = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.brakelights#count"), 0);
	self.brakelights = {};
	for i=1, self.numbrakelights do
		local brakelightnamei = string.format("vehicle.brakelights.brakelight" .. "%d", i);
		self.brakelights[i] = Utils.indexToObject(self.rootNode, getXMLInt(xmlFile, brakelightnamei .. "#index"));
		setVisibility(self.brakelights[i], false);
	end;
	self.brakelightsActive = false;
	self.braking = false;
-- brakeLights_end
--capacity
    self.setFillLevel = SpecializationUtil.callSpecializationsFunction("setFillLevel");
	self.capacity2 = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.capacity2"), 0);
	self.grainPlane2MaxY = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.grainPlane2#maxY"),0);
	self.safeCapacity = self.capacity;
	self.safeGrainPlaneMaxY = self.grainPlaneMaxY;
--capacity_end
-- tipamination
    local tipAnimRootNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tipAnimation#rootNode"));
    self.tipAnimCharSet = 0;
    if tipAnimRootNode ~= nil and tipAnimRootNode ~= 0 then
        self.tipAnimCharSet = getAnimCharacterSet(tipAnimRootNode);
        if self.tipAnimCharSet ~= 0 then
            self.clip = getAnimClipIndex(self.tipAnimCharSet, getXMLString(xmlFile, "vehicle.tipAnimation#clip"));
            self.clipleft = getAnimClipIndex(self.tipAnimCharSet, getXMLString(xmlFile, "vehicle.tipAnimation#clipleft"));
            self.clipback = getAnimClipIndex(self.tipAnimCharSet, getXMLString(xmlFile, "vehicle.tipAnimation#clipback"));

            setAnimTrackLoopState(self.tipAnimCharSet, 0, false);
            self.tipAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.tipAnimation#speedScale"), 1);
            self.tipAnimDuration = getAnimClipDuration(self.tipAnimCharSet, self.clip);
            if self.tipDischargeEndTime == nil then
                self.tipDischargeEndTime = self.tipAnimDuration*2.0;
            end;
        end;
    end;

    self.tipReferencePointright = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tipReferencePointright#index"));
    self.tipReferencePointleft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tipReferencePointleft#index"));
	self.tipReferencePointback = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tipReferencePointback#index"));	

    self.tipright = true;
    self.tipleft = false;
    self.tipback = false;

-- particleSystem
    self.dischargeParticleSystemsright = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.dischargeParticleSystemsright.dischargeParticleSystemright(%d)", i);
        local t = getXMLString(xmlFile, key .. "#type");
        if t == nil then
            break;
        end;
        local desc = FruitUtil.fruitTypes[t];
        if desc ~= nil then
            local currentPS = {};

            local particleNode = Utils.loadParticleSystem(xmlFile, currentPS, key, self.components, false, "", self.baseDirectory);
            self.dischargeParticleSystemsright[desc.index] = currentPS;
            if self.defaultdischargeParticleSystems == nil then
                self.defaultdischargeParticleSystems = currentPS;
            end;
        end;
        i = i + 1;
    end;

    self.dischargeParticleSystemsleft = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.dischargeParticleSystemsleft.dischargeParticleSystemleft(%d)", i);
        local t = getXMLString(xmlFile, key .. "#type");
        if t == nil then
            break;
        end;
        local desc = FruitUtil.fruitTypes[t];
        if desc ~= nil then
            local currentPS = {};

            local particleNode = Utils.loadParticleSystem(xmlFile, currentPS, key, self.components, false, "", self.baseDirectory);
            self.dischargeParticleSystemsleft[desc.index] = currentPS;
            if self.defaultdischargeParticleSystems == nil then
                self.defaultdischargeParticleSystems = currentPS;
            end;
        end;
        i = i + 1;
    end;
	
    self.dischargeParticleSystemsback = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.dischargeParticleSystemsback.dischargeParticleSystemback(%d)", i);
        local t = getXMLString(xmlFile, key .. "#type");
        if t == nil then
            break;
        end;
        local desc = FruitUtil.fruitTypes[t];
        if desc ~= nil then
            local currentPS = {};

            local particleNode = Utils.loadParticleSystem(xmlFile, currentPS, key, self.components, false, "", self.baseDirectory);
            self.dischargeParticleSystemsback[desc.index] = currentPS;
            if self.defaultdischargeParticleSystems == nil then
                self.defaultdischargeParticleSystems = currentPS;
            end;
        end;
        i = i + 1;
    end;
-- particleSystem_end

--modus
	self.modusColli = false;
	self.modusCargo = false;
	self.modusGrainA = false;
	self.modusGrainB = false;

	self.plateformgate1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate1#index"));
	self.plateformgate2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate2#index"));
	self.plateformgate3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate3#index"));
	self.plateformgate4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate4#index"));
	self.plateformgate5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate5#index"));
	
	self.modus = 0;
	self.setModus = SpecializationUtil.callSpecializationsFunction("setModus");
	self:setModus(3);
--modus_end
--tarpaulin
	self.plane1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plane1#index"));
	self.plane1Active1st = false;
	self.plane1Active2nd = false;
	setVisibility(self.plane1, false);
	
	self.plane2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plane2#index"));
	setVisibility(self.plane2, true);
--tarpaulin_end
--openGate--
	self.colliGate1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.colligate1#index"));
	self.colliGate2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.colligate2#index"));

	local rotationPartNodeGateRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate1#index"));
    if rotationPartNodeGateRight ~= nil then
        self.rotationPartGateRight = {};
        self.rotationPartGateRight.node = rotationPartNodeGateRight;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.plateformgate1#minRot"));
        self.rotationPartGateRight.minRot = {};
        self.rotationPartGateRight.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartGateRight.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartGateRight.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.plateformgate1#maxRot"));
        self.rotationPartGateRight.maxRot = {};
        self.rotationPartGateRight.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartGateRight.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartGateRight.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartGateRight.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.plateformgate1#rotTime"), 2)*1000;
    end;
	self.rotationMaxGateRight = false;
	
	local rotationPartNodeGateLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.plateformgate2#index"));
    if rotationPartNodeGateLeft ~= nil then
        self.rotationPartGateLeft = {};
        self.rotationPartGateLeft.node = rotationPartNodeGateLeft;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.plateformgate2#minRot"));
        self.rotationPartGateLeft.minRot = {};
        self.rotationPartGateLeft.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartGateLeft.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartGateLeft.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.plateformgate2#maxRot"));
        self.rotationPartGateLeft.maxRot = {};
        self.rotationPartGateLeft.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartGateLeft.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartGateLeft.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartGateLeft.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.plateformgate2#rotTime"), 2)*1000;
    end;
	self.rotationMaxGateLeft = false;
--openGate_end--
--balesFixed
	self.balesInRangePoint = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.balesInRangePoint#index"));
	self.setBalesInRange = SpecializationUtil.callSpecializationsFunction("setBalesInRange");
	self.balesSafety = false;
	self.isRoundBalesActive = false;
	self.isQuaderBalesActive = false;

	self.numRBAttachers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.RoundBalesAttachers#count"), 0);
	self.RBAttacher = {};
	
	for i=1, self.numRBAttachers do
	 self.RBAttacher[i] = {};
	 local partnamei = string.format("vehicle.RoundBalesAttachers.balesAttacher".."%d",i);
	 self.RBAttacher[i].object = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	 setRigidBodyType(self.RBAttacher[i].coll,"none")
	 self.RBAttacher[i].attachedObject = nil;
	 self.RBAttacher[i].objectInRange = nil;
	end;

	self.numQBAttachers = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.QuaderBalesAttachers#count"), 0);
	self.QBAttacher = {};
	
	for i=1, self.numQBAttachers do
	 self.QBAttacher[i] = {};
	 local partnamei = string.format("vehicle.QuaderBalesAttachers.balesAttacher".."%d",i);
	 self.QBAttacher[i].object = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, partnamei .. "#index"));
	 setRigidBodyType(self.QBAttacher[i].coll,"none")
	 self.QBAttacher[i].attachedObject = nil;
	 self.QBAttacher[i].objectInRange = nil;
	end;
--balesFixed_end
	
--infoHud
    self.infoHudpath = Utils.getFilename("scripts/info_hud.png", self.baseDirectory);
    self.infoHudPoxX = 0.8325;
    self.infoHudPoxY = (1-0.492);
    self.infoHudWidth = 0.16;
    self.infoHudHeight = 0.16;
    self.infoHudOverlay = Overlay:new("infoHudDisplay", self.infoHudpath, self.infoHudPoxX, self.infoHudPoxY, self.infoHudWidth, self.infoHudHeight);

	self.infoHud = true;
--infoHud_end
--helpHud
    self.helpHudpath = Utils.getFilename("scripts/help_hud.png", self.baseDirectory);
    self.helpHudPoxX = 0.01;
    self.helpHudPoxY = 0.01;
    self.helpHudWidth = 0.5;
    self.helpHudHeight = 0.25;
    self.helpHudOverlay = Overlay:new("helpHudDisplay", self.helpHudpath, self.helpHudPoxX, self.helpHudPoxY, self.helpHudWidth, self.helpHudHeight);

	self.helpHud = false;
--helpHud_end

--trailerType
	self.attached = true;
--trailerType_end

--warning
	self.warningTextGrain = false;
	self.warningTextBales = false;
	self.warningCount = false;
--warning_end

end;

function bergmann:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
    local modus = getXMLFloat(xmlFile, key.."#Modus");
    if modus ~= nil then
		self:setModus(modus);
	end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function bergmann:getSaveAttributesAndNodes(nodeIdent)
    local attributes = 'Modus="'..self.modus..'"';
	for i=1, self.numRBAttachers do
        BergmannObjectDetach(self,i)
    end;
	for i=1, self.numQBAttachers do
        BergmannObjectQBDetach(self,i)
    end;
	
    return attributes, nil;
end;

function bergmann:delete()
	Utils.deleteParticleSystem(self.dischargeParticleSystemsright);
	Utils.deleteParticleSystem(self.dischargeParticleSystemsleft);
	Utils.deleteParticleSystem(self.dischargeParticleSystemsback);
end;

function bergmann:mouseEvent(posX, posY, isDown, isUp, button)
end;

function bergmann:keyEvent(unicode, sym, modifier, isDown)

	if InputBinding.isPressed(InputBinding.TOGGLE_TIPRIGHT) then
		self.tipright = true;
		self.tipleft = false;
		self.tipback = false;
		self.rotationMaxGateRight = false;
		self.rotationMaxGateLeft = false;		
	end;
	if InputBinding.isPressed(InputBinding.TOGGLE_TIPLEFT) then
		self.tipleft = true;
		self.tipright = false;
		self.tipback = false;
		self.rotationMaxGateRight = false;
		self.rotationMaxGateLeft = false;	
	end;
	if InputBinding.isPressed(InputBinding.TOGGLE_TIPBACK) then
		self.tipback = true;
		self.tipleft = false;
		self.tipright = false;
		self.rotationMaxGateRight = false;
		self.rotationMaxGateLeft = false;	
	end;
	if InputBinding.isPressed(InputBinding.TOGGLE_INFOHUD) then
		self.infoHud = not self.infoHud;
	end;
	if InputBinding.isPressed(InputBinding.TOGGLE_HELPHUD) then
		self.helpHud = not self.helpHud;
	end;
	
	if self.modus == 1 then
	if InputBinding.isPressed(InputBinding.TOGGLE_GATEMOVE) then
		if self.tipback then
			self.rotationMaxGateRight = not self.rotationMaxGateRight;
			self.rotationMaxGateLeft = not self.rotationMaxGateLeft;
		elseif self.tipright then
			self.rotationMaxGateRight = not self.rotationMaxGateRight;
		elseif self.tipleft then
			self.rotationMaxGateLeft = not self.rotationMaxGateLeft;
		end;
	end;
	end;
	
	if self.modus == 3 then
		if InputBinding.isPressed(InputBinding.TOGGLE_PLANE_A) then
			self.plane1Active1st = not self.plane1Active1st;
		end;
		if InputBinding.isPressed(InputBinding.TOGGLE_PLANE_B) then
			self.plane1Active2nd = not self.plane1Active2nd;
		end;
	end;	
end;

function bergmann:update(dt)
-- brakeLights
	local inputAxisY = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);

	if self.attacherVehicle ~= nil then
		if self.brakelightsActive then
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive);
			end;
		else
			for i=1, self.numbrakelights do
				local brakelight = self.brakelights[i];
				setVisibility(brakelight, self.brakelightsActive, false);
			end;
		end;
		if (self.attacherVehicle.movingDirection*self.attacherVehicle.lastSpeed*(-inputAxisY)) < -0.001 then		
			self.brakelightsActive = true;
			self.braking = true;
		else
			self.brakelightsActive = false;
			self.braking = false;
		end;
	end;
-- brakeLights_end
--tipamination
	if self.tipState == Trailer.TIPSTATE_CLOSED then
		if self.tipright then
		self.tipReferencePoint = self.tipReferencePointright;
		assignAnimTrackClip(self.tipAnimCharSet, 0, self.clip);
		end;
		if self.tipleft then
		self.tipReferencePoint = self.tipReferencePointleft;
		assignAnimTrackClip(self.tipAnimCharSet, 0, self.clipleft);
		end;
		if self.tipback then
		self.tipReferencePoint = self.tipReferencePointback;
		assignAnimTrackClip(self.tipAnimCharSet, 0, self.clipback);
		end;
	end;
--tipamination_end
-- particleSystem
	if self.tipright then
        Utils.setEmittingState(self.dischargeParticleSystemsright[self.currentFillType], self.lastFillDelta < 0);
	end;
	if self.tipleft then
        Utils.setEmittingState(self.dischargeParticleSystemsleft[self.currentFillType], self.lastFillDelta < 0);
    end;
	if self.tipback then
        Utils.setEmittingState(self.dischargeParticleSystemsback[self.currentFillType], self.lastFillDelta < 0);
	end;
-- particleSystem_end

--modus
	if self.modus == 0 then
		self.modusColli = false;
		self.modusCargo = false;
		self.modusGrainA = false;
		self.modusGrainB = false;
		self.plane1Active1st = false
		self.plane1Active2nd = false
		self.allowFillFromAir = false;

	elseif self.modus == 1 then
		self.modusColli = true;
		self.modusCargo = true;
		self.modusGrainA = false;
		self.modusGrainB = false;

		self.allowFillFromAir = false;
		
	elseif self.modus == 2 then
		self.modusColli = false;
		self.modusCargo = true;
		self.modusGrainA = true;
		self.modusGrainB = false;
		self.plane1Active1st = false;
		self.plane1Active2nd = false;
		self.allowFillFromAir = true;
		self.capacity = self.capacity2;
		self.grainPlaneMaxY = self.grainPlane2MaxY;

	elseif self.modus == 3 then
		self.modusColli = false;
		self.modusCargo = true;
		self.modusGrainA = true;
		self.modusGrainB = true;
		self.plane2Active1st = true;
		self.plane2Active2nd = true;
		self.capacity = self.safeCapacity;
		self.grainPlaneMaxY = self.safeGrainPlaneMaxY;
	end;

	if self.modusColli then
		setCollisionMask(self.colliGate1, 2102);
		setRigidBodyType(self.colliGate1, "Dynamic");
		setCollisionMask(self.colliGate2, 2102);
		setRigidBodyType(self.colliGate2, "Dynamic");
	else
		setCollisionMask(self.colliGate1, 0)
		setRigidBodyType(self.colliGate1, "None");
		setCollisionMask(self.colliGate2, 0)
		setRigidBodyType(self.colliGate2, "None");
	end;
	
	if self.modusCargo then
		setVisibility(self.plateformgate1, self.modusCargo);
		setVisibility(self.plateformgate2, self.modusCargo);
	else
		setVisibility(self.plateformgate1, self.modusCargo, false);
		setVisibility(self.plateformgate2, self.modusCargo, false);
	end;

	if self.modusGrainA then
		setVisibility(self.plateformgate3, self.modusGrainA);
		setVisibility(self.plateformgate4, self.modusGrainA);
	else
		setVisibility(self.plateformgate3, self.modusGrainA, false);
		setVisibility(self.plateformgate4, self.modusGrainA, false);
	end;
	
	if self.modusGrainB then
		setVisibility(self.plateformgate5, self.modusGrainB);
	else
		setVisibility(self.plateformgate5, self.modusGrainB, false);
	end;

	self:setBalesInRange ();
	
	if self:getIsActiveForInput() then
		if InputBinding.hasEvent(InputBinding.TOGGLE_MODUS) then
			if self.modus == 0 and self.balesInRange == false and self.balesSafety == false then
				self:setModus(self.modus + 1);
			elseif (self.modus == 0 and self.balesInRange == true and self.warningCount == false) or (self.modus == 0 and self.balesSafety == true and self.warningCount == false) then	
				self.warningTextBales = true;
				self.warningCount = true;
			elseif (self.modus == 0 and self.balesInRange == true and self.warningCount == true) or (self.modus == 0 and self.balesSafety == true and self.warningCount == true) then	
				self.warningTextBales = false;
				self.warningCount = false;
			elseif self.modus == 1 then
				self:setModus(self.modus + 1);
				self.rotationMaxGateRight = false;
				self.rotationMaxGateLeft = false;
			elseif self.modus == 2 then 
				self:setModus(self.modus + 1);
				self.warningCount = false;
			elseif self.modus == 3 and self.fillLevel == 0 then 
				self:setModus(self.modus - 3);
			elseif self.modus == 3 and self.fillLevel > 0 and self.warningCount == false then
				self.warningTextGrain = true;
				self.warningCount = true;
			elseif self.modus == 3 and self.fillLevel > 0 and self.warningCount == true then
				self.warningCount = false;
			end;
		end;
		if InputBinding.hasEvent(InputBinding.TOGGLE_MODUSNEG) then
			if self.modus == 0 and self.balesInRange == false and self.balesSafety == false then
				self:setModus(self.modus + 3);
			elseif (self.modus == 0 and self.balesInRange == true and self.warningCount == false) or (self.modus == 0 and self.balesSafety == true and self.warningCount == false) then	
				self.warningTextBales = true;
				self.warningCount = true;
			elseif (self.modus == 0 and self.balesInRange == true and self.warningCount == true) or (self.modus == 0 and self.balesSafety == true and self.warningCount == true) then	
				self.warningTextBales = false;
				self.warningCount = false;				
			elseif self.modus == 1 then
				self:setModus(self.modus - 1);
				self.rotationMaxGateRight = false;
				self.rotationMaxGateLeft = false;
			elseif self.modus == 2 and self.fillLevel == 0 then 
				self:setModus(self.modus - 1);
			elseif self.modus == 2 and self.fillLevel > 0 and self.warningCount == false then
				self.warningTextGrain = true;
				self.warningCount = true;
			elseif self.modus == 2 and self.fillLevel > 0 and self.warningCount == true then
				self.warningCount = false;
			elseif self.modus == 3 and self.fillLevel <= self.capacity2 then 
				self:setModus(self.modus - 1);
				self.warningCount = false;
			end;
		end;
	end;
--modus_end
--balesFixed
	if self:getIsActiveForInput() and self.modus == 0 then
		if InputBinding.isPressed(InputBinding.TOGGLE_BALESDETACH) then
			if self.isRoundBalesActive then
				self.balesSafety = false;
				self.isRoundBalesActive = false;
				for i=1, self.numRBAttachers do
					BergmannObjectDetach(self,i)
				end;
			end;
			
			if self.isQuaderBalesActive then
				self.balesSafety = false;
				self.isQuaderBalesActive = false;
				for i=1, self.numQBAttachers do
					BergmannObjectQBDetach(self,i)
				end;
			end;
		end;

		if InputBinding.isPressed(InputBinding.TOGGLE_BALESATTACH) and self.balesInRange == true  then
			self.balesSafety = true;
			if self.isRoundBales then
				self.isRoundBalesActive = true;
				for i=1, self.numRBAttachers do
					nearest, index = BergmannObjectInRange(self,i);
					self.RBAttacher[i].objectInRange = nearest;
					BergmannObjectAttach(self,i)
				end;
			end;

			if self.isQuaderBales then
				self.isQuaderBalesActive = true;
				for i=1, self.numQBAttachers do
					nearest, index = BergmannObjectQBInRange(self,i);
					self.QBAttacher[i].objectInRange = nearest;
					BergmannObjectQBAttach(self,i)
				end;
			end;
		end;
	end;
--balesFixed_end

--openGate--
    if self.rotationPartGateRight ~= nil then
		local x, y, z = getRotation(self.rotationPartGateRight.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartGateRight.maxRot, self.rotationPartGateRight.minRot, 3, self.rotationPartGateRight.rotTime, dt, not self.rotationMaxGateRight);
		setRotation(self.rotationPartGateRight.node, unpack(newRot));
	end;
    if self.rotationPartGateLeft ~= nil then
		local x, y, z = getRotation(self.rotationPartGateLeft.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartGateLeft.maxRot, self.rotationPartGateLeft.minRot, 3, self.rotationPartGateLeft.rotTime, dt, not self.rotationMaxGateLeft);
		setRotation(self.rotationPartGateLeft.node, unpack(newRot));
	end;
--openGate_end--

--tarpaulin
	if g_currentMission.currentVehicle ~= nil then
		for i=1, table.getn(g_currentMission.currentVehicle.attachedImplements) do
			if g_currentMission.currentVehicle.attachedImplements[i].object then
				local trailer1 = g_currentMission.currentVehicle.attachedImplements[i].object;
				if trailer1.plane1Active1st then
					setVisibility(trailer1.plane1);
					setVisibility(trailer1.plane2, false);
					trailer1.allowFillFromAir = false;
				else
					setVisibility(trailer1.plane1, false);
					setVisibility(trailer1.plane2);
					trailer1.allowFillFromAir = true;
				end;
			end;
		end;
	end;
	
	for i=1, table.getn(self.attachedImplements) do
		if self.attachedImplements[i].object then
			local trailer2 = self.attachedImplements[i].object;
			if trailer2.plane1Active2nd then
				setVisibility(trailer2.plane1);
				setVisibility(trailer2.plane2, false);
				trailer2.allowFillFromAir = false;
			else
				setVisibility(trailer2.plane1, false);
				setVisibility(trailer2.plane2);
				trailer2.allowFillFromAir = true;
			end;
		end;
	end;
--tarpaulin_end	
	
end;

function bergmann:draw()

	if self.attached then
	if self.warningTextGrain and self.warningCount then
		setTextBold(true);
		g_currentMission:addWarning(g_i18n:getText("unload only grain!"), 0.095, 0.033, 0.06);
		setTextBold(false);
	end;
	if self.warningTextBales and self.warningCount then
		setTextBold(true);
		g_currentMission:addWarning(g_i18n:getText("unload only bales!"), 0.095, 0.033, 0.06);
		setTextBold(false);
	end;
	end;
	
	if g_currentMission.currentVehicle ~= nil then
		for i=1, table.getn(g_currentMission.currentVehicle.attachedImplements) do
			if g_currentMission.currentVehicle.attachedImplements[i].object and g_currentMission.currentVehicle.attachedImplements[i].object.isSelected then
				trailer1 = g_currentMission.currentVehicle.attachedImplements[i].object;
				self.attached = true;
			end;
		end;
	end;
	
	for i=1, table.getn(self.attachedImplements) do
		if self.attachedImplements[i].object and self.attachedImplements[i].object.isSelected then
			trailer2 = self.attachedImplements[i].object;
			self.attached = false;
		end;
	end;

	if self.infoHud then
		setTextBold(true);
		if self.attached then
			self.infoHudOverlay:render();
			setTextColor(0, 0.498, 0.2745, 1.0);
			renderText(self.infoHudPoxX+0.012, self.infoHudPoxY+0.133, 0.03, g_i18n:getText("trailer info"));
			setTextColor(1.0, 1.0, 1.0, 1.0);
			if self.modus == 2 or self.modus == 3 then
				setTextColor(5.3, 8.3, 0.6, 1.0);
				if self.tipright then
					renderText(self.infoHudPoxX+0.06, self.infoHudPoxY+0.095, 0.03, g_i18n:getText("right"));
				elseif self.tipback  then
					renderText(self.infoHudPoxX+0.06, self.infoHudPoxY+0.095, 0.03, g_i18n:getText("back"));
				elseif self.tipleft then
					renderText(self.infoHudPoxX+0.06, self.infoHudPoxY+0.095, 0.03, g_i18n:getText("left"));
				end;
				setTextColor(1.0, 1.0, 1.0, 1.0);
				local percent = trailer1.fillLevel/trailer1.capacity*100;
				renderText(self.infoHudPoxX+0.02, self.infoHudPoxY+0.055, 0.03, string.format("%.0f(%d%%)", trailer1.fillLevel, percent));
			elseif self.modus == 1 then
				setTextColor(5.3, 8.3, 0.6, 1.0);
				if self.tipright then
					renderText(self.infoHudPoxX+0.06, self.infoHudPoxY+0.095, 0.03, g_i18n:getText("right side"));
				elseif self.tipback  then
					renderText(self.infoHudPoxX+0.06, self.infoHudPoxY+0.095, 0.03, g_i18n:getText("both sides"));
				elseif self.tipleft then
					renderText(self.infoHudPoxX+0.06, self.infoHudPoxY+0.095, 0.03, g_i18n:getText("left side"));
				end;
				setTextColor(1.0, 1.0, 1.0, 1.0);
			elseif self.modus == 0 and trailer1.balesSafety then
				renderText(self.infoHudPoxX+0.02, self.infoHudPoxY+0.055, 0.03, g_i18n:getText("bales"));
			end;
		else
			if trailer2 then
				if self.modus == 2 or self.modus == 3 then
					local percent = trailer2.fillLevel/trailer2.capacity*100;
					renderText(self.infoHudPoxX+0.02, self.infoHudPoxY+0.01, 0.03, string.format("%.0f(%d%%)", trailer2.fillLevel, percent));
				elseif self.modus == 0 and trailer2.balesSafety then
					renderText(self.infoHudPoxX+0.02, self.infoHudPoxY+0.01, 0.03, g_i18n:getText("bales"));
				end;
			end;
		end;
	end;
	
	
	if self.helpHud then
		setTextBold(true);
		if self.attached then
			self.helpHudOverlay:render();
			renderText(self.helpHudPoxX+0.015, self.helpHudPoxY+0.125, 0.025, string.format("%s/%s"..g_i18n:getText("Mode change"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_MODUSNEG), InputBinding.getButtonKeyName(InputBinding.TOGGLE_MODUS)));
			renderText(self.helpHudPoxX+0.015, self.helpHudPoxY+0.05, 0.025, string.format("%s"..g_i18n:getText("info on/off"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_INFOHUD)));
			renderText(self.helpHudPoxX+0.015, self.helpHudPoxY+0.025, 0.025, string.format("%s"..g_i18n:getText("help on/off"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_HELPHUD)));
			if self.modus == 2 or self.modus == 3 then
				renderText(self.helpHudPoxX+0.125, self.helpHudPoxY+0.1575, 0.04, g_i18n:getText("Harvest property"));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.125, 0.025, string.format("%s"..g_i18n:getText("to the left tip"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_TIPLEFT)));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.1, 0.025, string.format("%s"..g_i18n:getText("to the back tip"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_TIPBACK)));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.075, 0.025, string.format("%s"..g_i18n:getText("to the right tip"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_TIPRIGHT)));
				if self.modus == 3 then
					renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.05, 0.025, string.format("%s"..g_i18n:getText("tarpaulin 1st trailer"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_PLANE_A)));
					renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.025, 0.025, string.format("%s"..g_i18n:getText("tarpaulin 2nd trailer"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_PLANE_B)));
				end;
			elseif self.modus == 1 then
				renderText(self.helpHudPoxX+0.125, self.helpHudPoxY+0.1575, 0.04, g_i18n:getText("palettes/boxes"));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.125, 0.025, string.format("%s"..g_i18n:getText("left gate"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_TIPLEFT)));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.1, 0.025, string.format("%s"..g_i18n:getText("both gates"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_TIPBACK)));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.075, 0.025, string.format("%s"..g_i18n:getText("right gate"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_TIPRIGHT)));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.05, 0.025, string.format("%s"..g_i18n:getText("open/close"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_GATEMOVE)));
			elseif self.modus == 0 then
				renderText(self.helpHudPoxX+0.125, self.helpHudPoxY+0.1575, 0.04, g_i18n:getText("bales"));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.125, 0.025, string.format("%s"..g_i18n:getText("bales protect"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_BALESATTACH)));
				renderText(self.helpHudPoxX+0.257, self.helpHudPoxY+0.1, 0.025, string.format("%s"..g_i18n:getText("bales release"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_BALESDETACH)));
			end;
		end;
		else
		if self.attached then
			renderText((1-0.165), 0.15, 0.02, string.format("%s"..g_i18n:getText("help on"), InputBinding.getButtonKeyName(InputBinding.TOGGLE_HELPHUD)));
		end;
	end;
end;

function bergmann:onAttach(attacherVehicle)
	if attacherVehicle.infoHud ~= nil then
		self.infoHud = attacherVehicle.infoHud;
	else
		self.infoHud = true;
	end;
end;

function bergmann:setFillLevel(fillLevel, fillType)
    if not self:allowFillType(fillType, false) then
        return;
    end;

    self.currentFillType = fillType;
    self.fillLevel = fillLevel;
    if self.fillLevel > self.capacity then
        self.fillLevel = self.capacity;
    end;
    if self.fillLevel < 0 then
        self.fillLevel = 0;
        Utils.setEmittingState(self.dischargeParticleSystemsback[self.currentFillType], false);
        Utils.setEmittingState(self.dischargeParticleSystemsleft[self.currentFillType], false);
        Utils.setEmittingState(self.dischargeParticleSystemsright[self.currentFillType], false);
        self.currentFillType = FruitUtil.FRUITTYPE_UNKNOWN;
    end;
end;

function bergmann:setModus(modus)
    self.modus = modus;
end;

function bergmann:setBalesInRange()
	self.balesInRange = false;
	self.isRoundBales = false;
	self.isQuaderBales = false;

	local nearestDistance = 2;
	local px, py, pz = getWorldTranslation(self.balesInRangePoint);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    local itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isRoundStrawbale") or getUserAttribute(itemNode, "isRoundHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					self.balesInRange = true;
					self.isRoundBales = true;
				end;
			end;
			if getUserAttribute(itemNode, "isHaybale") or getUserAttribute(itemNode, "isStrawbale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					self.balesInRange = true;
					self.isQuaderBales = true;
				end;
			end;
		end;
	end;
end;

function BergmannObjectInRange(self,k)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 1;
	local objectCopy = self.RBAttacher[k].object;	
	local px, py, pz = getWorldTranslation(objectCopy);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isRoundStrawbale") or getUserAttribute(itemNode, "isRoundHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = i
					nearestObject = itemNode
					nearestDistance = distance
				end;
			end;
		end;
	end;

	return nearestObject, index;

end;

function BergmannObjectQBInRange(self,k)
	local nearestObject
	local itemNode
	local index 
	local nearestDistance = 0.4;
	local objectCopy = self.QBAttacher[k].object;	
	local px, py, pz = getWorldTranslation(objectCopy);
	for i=1, table.getn(g_currentMission.itemsToSave) do
	    itemNode = g_currentMission.itemsToSave[i].node;
	    if getParent(g_currentMission.itemsToSave[i].node) == getRootNode() then
			if getUserAttribute(itemNode, "isStrawbale") or getUserAttribute(itemNode, "isHaybale") then
				local vx, vy, vz = getWorldTranslation(itemNode);
				local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);
				if distance < nearestDistance then
					index = i
					nearestObject = itemNode
					nearestDistance = distance
				end;
			end;
		end;
	end;

	return nearestObject, index;

end;

function BergmannObjectAttach(self,k)
	if self.RBAttacher[k].objectInRange ~= nil then
		if self.RBAttacher[k].attachedObject == nil then
			setRigidBodyType(self.RBAttacher[k].objectInRange,"none");
			local x,y,z = getWorldRotation(self.RBAttacher[k].objectInRange);		
			link(self.RBAttacher[k].object,self.RBAttacher[k].objectInRange);
			setRotation(self.RBAttacher[k].objectInRange, 0,0,0);
			setTranslation(self.RBAttacher[k].objectInRange, 0,0,0)
			self.RBAttacher[k].attachedObject = self.RBAttacher[k].objectInRange;
			self.RBAttacher[k].objectInRange = nil;
		end;
	end;
end;

function BergmannObjectQBAttach(self,k)
	if self.QBAttacher[k].objectInRange ~= nil then
		if self.QBAttacher[k].attachedObject == nil then
			setRigidBodyType(self.QBAttacher[k].objectInRange,"none");
			local x,y,z = getWorldRotation(self.QBAttacher[k].objectInRange);		
			link(self.QBAttacher[k].object,self.QBAttacher[k].objectInRange);
			setRotation(self.QBAttacher[k].objectInRange, 0,0,0);
			setTranslation(self.QBAttacher[k].objectInRange, 0,0,0)
			self.QBAttacher[k].attachedObject = self.QBAttacher[k].objectInRange;
			self.QBAttacher[k].objectInRange = nil;
		end;
	end;
end;

function BergmannObjectDetach(self,k)
	if self.RBAttacher[k].attachedObject ~= nil then			
		local x,y,z = getWorldTranslation(self.RBAttacher[k].attachedObject)
		local rx,ry,rz = getWorldRotation(self.RBAttacher[k].attachedObject)
		local root = getRootNode()
		setTranslation(self.RBAttacher[k].attachedObject,x,y,z)
		setRotation(self.RBAttacher[k].attachedObject,rx,ry,rz)
		link(root,self.RBAttacher[k].attachedObject)
		setRigidBodyType(self.RBAttacher[k].attachedObject,"Dynamic")
		self.RBAttacher[k].attachedObject = nil;
	end;
end;

function BergmannObjectQBDetach(self,k)
	if self.QBAttacher[k].attachedObject ~= nil then			
		local x,y,z = getWorldTranslation(self.QBAttacher[k].attachedObject)
		local rx,ry,rz = getWorldRotation(self.QBAttacher[k].attachedObject)
		local root = getRootNode()
		setTranslation(self.QBAttacher[k].attachedObject,x,y,z)
		setRotation(self.QBAttacher[k].attachedObject,rx,ry,rz)
		link(root,self.QBAttacher[k].attachedObject)
		setRigidBodyType(self.QBAttacher[k].attachedObject,"Dynamic")
		self.QBAttacher[k].attachedObject = nil;
	end;
end;